#!/usr/bin/env python
# coding=utf-8

import random
import time
import statistics
#Algorithmes de colonies de fourmis

#But : trouver le chemin le plus court de A à B 
#contrainte : Passer par toutes les villes
#-- Partie I --
#Etape 1 : Initialiser 1 fourmi par ville
#Etape 2 : faire visiter toutes les villes (chemin cout + faible)
#=> retenir les chemins empruntés
#Etape 3 : Ajouter +1 à tout les chemins empruntés

#-- Partie II --
#Etape 1 : Initialiser fourmis aléatoirement aux villes
#Etape 2 : faire visiter toutes les villes (chemins les plus empruntés)
#=> Si passages égaux => random
#Etape 3 : Répéter Partie II n fois

def chargement(nom):
    fichier = open(nom,"r")
    Matrix = []
    count = 0;
    for i in fichier:
        #i.strip()
        ligne = i.split(",")
        ligne[len(ligne)-1] = ligne[len(ligne)-1].rstrip('\n')
        for j in range(0, len(ligne)):
            ligne[j] = int(ligne[j])

        Matrix.append(ligne)

    #print (Matrix)

    return Matrix

#Initialisation des phéromone à 0
def init_trace(taille):
    tab_trace = []

    for i in range(0,taille):
        ligne = [100]*taille
        tab_trace.append(ligne)
    #print(tab_trace)
    return tab_trace

def sum_tab(tab):
    total=0
    for i in range(0,len(tab)):
        total += tab[i]
    return total
        



def evaporation(tab_trace,p):
    for i in range(0,len(tab_trace)):
        for j in range(0,len(tab_trace)):
            #print("Avant",(tab_trace[j])[i])
            (tab_trace[i])[j] = int((tab_trace[i])[j]*(1-p)) +10
            (tab_trace[j])[i] = int((tab_trace[j])[i]*(1-p)) +10
            #print("apres",(tab_trace[j])[i])
            if ( j == i):
                (tab_trace[j])[i] = 0
            
    return tab_trace
    

def renforcement(tab,tab_trace,k):

    the_max = 0;
    for i in range(0,len(tab_trace)):
        for j in range(0,len(tab_trace)):
            
            #if (k>=3):
             #   print(1/pow((tab[i])[j],k), "k :",k)
              #  time.sleep(0.2)
            if (i>j):

                    
                (tab_trace[i])[j] = (tab_trace[i])[j] + (1/pow((tab[i])[j],k))*pow(10,3*(k+1))/(k+1)
                (tab_trace[j])[i] = (tab_trace[j])[i] + (1/pow((tab[i])[j],k))*pow(10,3*(k+1))/(k+1)
                
                
            if ( j == i):
                (tab_trace[j])[i] = min(tab_trace[j])
    return tab_trace



def matrice_sup_to_all(tab):
    for i in range(0,len(tab)):
        for j in range(0,len(tab)):

            if (j>i):
                #print((tab[i])[j])
                (tab[j])[i] = (tab[i])[j]
    return tab

def get_ville(tab_trace,ville,visited):
    
    temp_tab_trace = [x for x in tab_trace[ville]]
    for x in range(0,len(visited)):
        if visited[x] == 1:
            temp_tab_trace[x] = 0
    
    the_min = min(temp_tab_trace)
    the_sum = sum(temp_tab_trace)

    nb_random = int(random.uniform(the_min, the_sum+1))

    if (nb_random- (tab_trace[ville])[ville] >= the_min):
        nb_random = nb_random- temp_tab_trace[ville]

    
    if (nb_random > the_sum):
        nb_random = the_sum
        
    nb_rand = nb_random


    indice = -1

    #print(nb_random)
    #print(the_sum)

    
    while(nb_random > 0 ):
        indice += 1

        if (indice != ville):
            nb_random = nb_random - temp_tab_trace[indice]

    #print(indice)

    #print("The min:",the_min)
    #print("The sum:",the_sum)
    #print("The random:",nb_rand)
    #time.sleep(0.4)
    return indice
    
    


def iteration(tab,tab_trace,ville):
    
    visited = [0] * (len(tab))
    visited[ville] = 1

    for i in range(0,len(tab)-1):
        next_ville = ville
        while(visited[next_ville] == 1):
            next_ville = get_ville(tab_trace,ville,visited)

        (tab_trace[ville])[next_ville] += 100
        (tab_trace[next_ville])[ville] += 100

        ville = next_ville
        visited[ville] = 1
        #print("lol")

    return tab_trace
    
    
    
def cout(tab,tab_trace):
    ligne_du_max = 0
    the_max = 0
    chemin = [" "]*len(tab)
    for i in range(0,len(tab)):
        if (max(tab_trace[i])>the_max):
            ligne_du_max = i
            the_max = max(tab_trace[i])

    visited = [0] * (len(tab))
    visited[ligne_du_max] = 1
    
    ville = ligne_du_max


    #print("Avantboucle",visited)

    cout = 0;
    for i in range(0,len(tab)-1):
        the_max = 0
        indice = 0
        for j in range(0,len(tab)):
            if (ville != j):
                if (the_max<(tab_trace[ville])[j] and visited[j] == 0):

                    the_max = (tab_trace[ville])[j]
                    indice = j

        #print((tab[ville])[indice])
        cout = cout + (tab[ville])[indice]
        chemin[i] = "",ville,",",indice,""
        ville = indice
        visited[ville] = 1
        #print("i:",i)
        #print(visited)
    #print(chemin)
    return cout

def normalisation(tab,j):
    the_max = 0 #->5000
    for i in range(0,len(tab)):
        if (max(tab[i]) > the_max):
            the_max = max(tab[i])
    for i2 in range(0,len(tab)):
            for j in range(0,len(tab)):
                #(tab[i2])[j] = int((tab[i2])[j] * (5000)/the_max)
                (tab[i2])[j] = int((tab[i2])[j] * (the_max/(j+1))/the_max)

    return tab


            
def fourmis(nb_fourmis):
    #print("-- Debut du programme --\n")
    
    #print("** Chargement du fichier **")
    #Chargement du fichier 
    tab = chargement("matriceArel.txt");
    tab = matrice_sup_to_all(tab)
    #print("Table des couts")
    #print(tab)
    
    #Creation des phéromones
    tab_trace = init_trace(len(tab))
    #print("Table des phéromones à 0")
    #print(tab_trace)

    #print("Iteration")
    for i in range (0,len(tab)):
        tab_trace = iteration(tab,tab_trace,i)
        tab_trace = evaporation(tab_trace,0.4)



    #print(tab_trace)

    nb_iteration = nb_fourmis
    for j in range(0,nb_iteration):
        #print(tab_trace)
        ville_rand = int(random.uniform(0,len(tab_trace)))
        #print("**Iteration ",j," **")
        tab_trace = iteration(tab,tab_trace,ville_rand)
        #print("EVAPORATION")
        tab_trace = evaporation(tab_trace,0.4)
        #print("RENFORCEMENT")
        tab_trace = renforcement(tab,tab_trace,j)
        #tab_trace = normalisation(tab_trace,j)

        print(cout(tab,tab_trace))

fourmis(100)









